#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <tcl.h>
#include <tk.h>
#include "mv1.h"

#if (TCL_MAJOR_VERSION!=8) && (TCL_MINOR_VERSION==0)
	#error Wrong tcl.h Version. You need Version 8.0
#endif
#if (TK_MAJOR_VERSION!=8) && (TK_MINOR_VERSION==0)
	#error Wrong tk.h Version. You need Version 8.0
#endif
#define MAX_INT (1<<30)

#define MV1_CONFIG_BOOL  	1
#define MV1_CONFIG_DOUBLE 	2
#define MV1_CONFIG_INT 		4
#define MV1_CONFIG_RADIO	8

#define MAX_RADIOS	12


struct MV1_settings_s;

typedef struct {
	Tcl_Interp *interp;
	MV1_Ctrl *bdCtrl;
	char *name;
	struct MV1_settings_s *settings;
	Tcl_HashTable nameHash;
	Tcl_HashTable s_ioctlHash;
	int board;
} MV1Ctrl;

typedef struct MV1_settings_s {
        char *name;
        int type;
        double from,to;
        char *valuelist[MAX_RADIOS];
//        char *valuelist;
	int (*libget)(MV1_Ctrl *);
	int (*libset)(u_long arg,MV1_Ctrl *);
        double (*get)(MV1Ctrl * );
	int g_ioctl;
        int (*set)(MV1Ctrl * ,double value);
	int s_ioctl;
	
} MV1_settings;

int MV1Open(ClientData ,Tcl_Interp *,int argc,char *argv[]);
void verifyGrabMachine(ClientData clientData);
int mv1_Save(MV1Ctrl *ctrl,int argc,char *argv[]);

